library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

ENTITY sn74181 IS
	PORT(
		A,B			: IN std_logic_vector(3 downto 0);
		s			: IN std_logic_vector(5 downto 0); -- S0S1S2S3 & M & Cn
		F			: OUT std_logic_vector(4 downto 0)
	);
END sn74181;

ARCHITECTURE a_ual OF sn74181 IS
	SIGNAL temp			: std_logic_vector(3 downto 0);
BEGIN
	temp <= "000"&s(0);
	WITH s(5 downto 1) SELECT 	-- On ne prend pas la derniere valeur car le
								-- SELECT refuse de compiler avec l'tat 'X' et '-'
								-- qui aurait permi de prendre l'ensemble du vecteur s
		-- Oprations Logiques
		F <='0' & ( NOT A 		)	WHEN "00001",
			'0' & ( NOT (A OR B)) 	WHEN "00011",
			'0' & ( NOT A AND B	)	WHEN "00101",
			'0' & "0000"			WHEN "00111",
			'0' & (NOT (A AND B))	WHEN "01001",
			'0' & (NOT B 		)	WHEN "01011",
			'0' & (A XOR B 		)	WHEN "01101",
			'0' & (A AND NOT B	)	WHEN "01111",
			'0' & (NOT A OR B	)	WHEN "10001",
			'0' & (NOT (A XOR B))	WHEN "10011",
			'0' & B					WHEN "10101",
			'0' & (A AND B		)	WHEN "10111",
			'0' & "1111" 			WHEN "11001",
			'0' & (A OR NOT B	)	WHEN "11011",
			'0' & (A OR B 		)	WHEN "11101",
			'0' & A 				WHEN "11111",
		-- Oprations Arithmtiques
			'0' & (A + temp)						WHEN "00000",
			'0' & ((A OR B) + temp)					WHEN "00010",
			'0' & ((A OR NOT B) + temp) 			WHEN "00100",
			'0' & ("1111" + temp)					WHEN "00110",
			'0' & (A + (A AND NOT B) + temp)		WHEN "01000",
			'0' & ((A OR B) + (A AND NOT B) + temp) WHEN "01010",
			'0' & (A - B + temp)					WHEN "01100",
			'0' & ((A AND NOT B) - "0001" + temp)	WHEN "01110",
			'0' & (A + (A AND B) + temp)			WHEN "10000",
			'0' & (A + B + temp)					WHEN "10010",
			'0' & ((A OR NOT B) - (A AND B) + temp)	WHEN "10100",
			'0' & ((A AND B) - "0001" + temp)		WHEN "10110",
			'0' & (A + A + temp)					WHEN "11000",
			'0' & ((A OR B) + A + temp)				WHEN "11010",
			'0' & ((A OR NOT B) + A + temp)			WHEN "11100",
			'0' & (A - "0001" + temp)				WHEN "11110",
			'0' & "0000" 							WHEN OTHERS;
END a_ual;
